

// Controlling Cal Averas with an Infrared remote and 38 khz Infrared receiver module.
// modified from the original program found at http://www.righto.com/2009/08/multi-protocol-infrared-remote-library.html
// My thanks to Ken Shirrifs for his blog and for creating the IR receiver library
// Here is the link to the Infrared Library that you must add to the Arduino IDE
// https://github.com/shirriff/Arduino-IRremote
// This program was tested using the 38 Khz IR receiver module from Radio Shack part# 2760640
// the sensor is wired pin one to Arduino pin 14, pin 2 to Arduino/power supply ground, pin 3 to Arduino + 5 vdc.
// The TV Code used was for a Sony or Samsung TV programed into an Auvio universal remote control 

#include <Servo.h>
#include <IRremote.h>
const int pingPin =30; //left ping
const int pingPin1=33; //right ping
 int selectpin=32;// select ping or infrared
// some variables to define Cals 3 color LED eyes
int rightred=26;
int rightgreen=16;
int rightblue=17;
int leftred=18;
int leftgreen=19;
int leftblue=20;

int RECV_PIN = 24;// Arduino pin 14 on a Arduino Mega 2560 of course you can use any available digital I/O pin

// create the Servo Object's for the Servo.h library
Servo leftshoulder,leftelbow,rightshoulder,rightelbow,leftleg,leftknee,rightleg,rightknee;

IRrecv irrecv(RECV_PIN);
//decode_results results;

void setup()
{
  Serial.begin(9600);
  Serial3.begin(9600);
  pinMode(rightred, OUTPUT);
  pinMode(rightgreen, OUTPUT);
  pinMode(rightblue, OUTPUT);
  pinMode(leftred, OUTPUT);
  pinMode(leftgreen, OUTPUT);
  pinMode(leftblue, OUTPUT);
  pinMode (selectpin,INPUT);
   //pinMode(pingPin, INPUT);
    pinMode(pingPin1, INPUT);
  // common anode 3 color turn off leds with logic HIGH + 5 vdc
  digitalWrite (selectpin,HIGH);
  digitalWrite(leftred,HIGH);
  digitalWrite(leftgreen,HIGH);
  digitalWrite(leftblue,HIGH);
  digitalWrite(rightred,HIGH);
  digitalWrite(rightgreen,HIGH);
  digitalWrite(rightblue,HIGH);
// blue eyes On 
  digitalWrite(leftblue,LOW);digitalWrite(rightblue,LOW);
  
  //irrecv.enableIRIn(); // Start the receiver
  
  //create output for 8 servos their Arduino (Output PINS) and the Servo.h library
  leftshoulder.attach(3);leftelbow.attach(4);rightshoulder.attach(5);rightelbow.attach(6);
 leftleg.attach(7);leftknee.attach(8);rightleg.attach(9);rightknee.attach(10);
 servocenter();  
}

void loop() {
  
  if (Serial3.available())//chang to serial3 for use
  {
   char Calserial=Serial3.read();
  //end select ultrasonic
  
  
  //if (irrecv.decode(&results)) {
    //Serial.println(results.value); // prints the Infrared code number to the serial monitor when a button is pushed

  //have a drink
  //right arm up and elbow up Right button big remote
  //if(results.value ==1752382022){rightshoulder.write(160);delay(1000);rightelbow.write(140);Serial.println("Right button");}
  if(Calserial=='A'){rightshoulder.write(160);delay(1000);rightelbow.write(140);Serial.println("Right button"); leftshoulder.write(90);leftshoulder.write(0);delay(1000);leftelbow.write(20);delay(1000);servocenter();}
  //right arm abn elbow down Down Button Big remote
//if(results.value==412973352){rightshoulder.write(60);delay(1000);rightelbow.write(80);Serial.println("Left button");}
  
// left arm wave
// left arm and elbow up Left button Big remote
  if(Calserial=='B'){leftshoulder.write(90);leftshoulder.write(0);delay(1000);leftelbow.write(20);Serial.println("Up button");delay(1000); servocenter();}
 //left arm and elbow down Down button big remote
if(Calserial=='C'){leftshoulder.write(130);delay(1000);leftelbow.write(90);Serial.println("Down button"); delay(1000); servocenter();}
  
// Go Niners both arms and elbows up Number 1 button Big remote
if(Calserial=='D'){rightshoulder.write(180); leftshoulder.write(0);delay(1000);rightelbow.write(140);leftelbow.write(20);Serial.println("Number1 button");delay(1000); servocenter();} 
// both arms and elbows down number 2 button Big remote
 if(Calserial=='E'){rightshoulder.write(60); leftshoulder.write(130);delay(1000);rightelbow.write(90);leftelbow.write(90);Serial.println("number2 button");}


// Karate Kid Crane Kick up number 3 button Big remote
  if(Calserial=='F'){rightshoulder.write(180); leftshoulder.write(0);delay(1000);rightelbow.write(140);
leftelbow.write(20);leftleg.write(0);leftknee.write(0);Serial.println("number3 button");}

  // Karate Kid Crane Kick down number 4 button Big Remote
if(Calserial=='G'){leftleg.write(130);leftknee.write(90);rightleg.write(180);rightknee.write(90);delay(1000);rightleg.write(60);rightknee.write(90);
delay(1000);leftleg.write(130);leftknee.write(90); delay (1000);leftleg.write(0);leftknee.write(0);delay(1000); servocenter();Serial.println("number4 button");}

// control Cal's Eye color (RGB)...

// RED LED's On Danger Will Robinson 
 if(Calserial=='H'){digitalWrite(leftblue,HIGH);digitalWrite(rightblue,HIGH);digitalWrite(leftred,LOW);digitalWrite(rightred,LOW);    Serial.println("Number5 button");
 rightshoulder.write(160);delay(500);rightelbow.write(140); delay(500); servocenter();leftshoulder.write(0);delay(1000);leftelbow.write(20); delay(500); servocenter();
 rightshoulder.write(160);delay(500);rightelbow.write(140); delay(500); servocenter();leftshoulder.write(0);delay(1000);leftelbow.write(20); delay(500); servocenter();
 rightshoulder.write(160);delay(500);rightelbow.write(140); delay(500); servocenter();leftshoulder.write(0);delay(1000);leftelbow.write(20); delay(500); servocenter();
 rightshoulder.write(160);delay(500);rightelbow.write(140); delay(500); servocenter();leftshoulder.write(0);delay(1000);leftelbow.write(20); delay(500); servocenter();
 digitalWrite(leftred,HIGH);digitalWrite(rightred,HIGH);digitalWrite(leftblue,LOW);digitalWrite(rightblue,LOW);
 }

//dancing
//RED LED's Off
if(Calserial=='I'){digitalWrite(leftblue,HIGH);digitalWrite(rightblue,HIGH);digitalWrite(leftred,HIGH);digitalWrite(rightred,HIGH);digitalWrite(leftgreen,LOW);digitalWrite(rightgreen,LOW);Serial.println("Number6 button");
// both arms up both elbows up
rightshoulder.write(180); leftshoulder.write(0);delay(1000);rightelbow.write(140);leftelbow.write(20);delay (500);
// leg dance right shoulder down right elbow down
//
rightshoulder.write(60);delay(1000);rightelbow.write(80);
leftleg.write(0);leftknee.write(0);delay(800);leftleg.write(130);leftknee.write(90);delay(800);
 //left arm down
leftshoulder.write(130);delay(500);leftelbow.write(90);
rightleg.write(170);rightknee.write(140);delay(800);rightleg.write(60);rightknee.write(90);delay(800);

// left arm up
leftshoulder.write(90);leftshoulder.write(0);delay(1000);leftelbow.write(20);

//right arm down

rightshoulder.write(180); leftshoulder.write(0);delay(800);

leftleg.write(0);leftknee.write(0);delay(800);leftleg.write(130);leftknee.write(90);delay(800);rightshoulder.write(60);delay(1000);rightelbow.write(80);
rightleg.write(170);rightknee.write(140);delay(800);rightleg.write(60);rightknee.write(90);delay(800);
// left arm down
leftshoulder.write(130);delay(500);leftelbow.write(90);
digitalWrite(leftgreen,HIGH);digitalWrite(rightgreen,HIGH);digitalWrite(leftblue,LOW);digitalWrite(rightblue,LOW);
} //end dancing

// Running GREEN LED'S On
if(Calserial=='J'){digitalWrite(leftblue,HIGH);digitalWrite(rightblue,HIGH);digitalWrite(leftred,LOW);digitalWrite(rightred,LOW);digitalWrite(leftgreen,HIGH);digitalWrite(rightgreen,HIGH);

// do it again
//right arm up running
rightshoulder.write(160);rightelbow.write(160);

// left leg forward running
leftleg.write(0);leftknee.write(0);
//right leg back running
rightleg.write(10);rightknee.write(130);delay(800);


// left leg back running
leftleg.write(180);leftknee.write(20);
//right arm down 
rightshoulder.write(90);rightelbow.write(90);
//left arm up
leftshoulder.write(90);leftshoulder.write(0);
//right leg forward running
rightleg.write(130);rightknee.write(90);delay(800);
// do it again


//right arm up running
rightshoulder.write(160);rightelbow.write(160);

//left arm down 
leftshoulder.write(130);leftelbow.write(90);
// left leg forward running
leftleg.write(0);leftknee.write(0);
//right leg back running
rightleg.write(10);rightknee.write(130);delay(800);
// left leg back running
leftleg.write(180);leftknee.write(20);
//right arm down 
rightshoulder.write(90);rightelbow.write(90);
//left arm up
leftshoulder.write(90);leftshoulder.write(0);
//right leg forward running
rightleg.write(130);rightknee.write(90);delay(1200);

digitalWrite(leftgreen,HIGH);digitalWrite(rightgreen,HIGH);digitalWrite(leftred,HIGH);digitalWrite(rightred,HIGH);digitalWrite(leftblue,LOW);digitalWrite(rightblue,LOW);
servocenter(); //Serial.println("Number7 button");
}// End Running


// GREEN LED'S Off
//if(results.value==1747313982){digitalWrite(leftgreen,HIGH);digitalWrite(rightgreen,HIGH);Serial.println("number8 button");}

//BLUE LED'S On  
//if(results.value==2340753640){digitalWrite(leftblue,LOW);digitalWrite(rightblue,LOW);Serial.println("Number9 button");}

// BLUE LED'S Off
//if(results.value==86661734){digitalWrite(leftblue,HIGH);digitalWrite(rightblue,HIGH);Serial.println("Minus button");}
  
  // center all servos with the 0 button
  //if(results.value==3119867746){servocenter();Serial.println("Number0 button");}
     
      //irrecv.resume(); // Receive the next Infrared value value
      
//}// end of main IF statement****
 
 // ARM TALKING
 if(Calserial=='K'){
   //CHANGE EYES GREEN
   digitalWrite(leftblue,HIGH);digitalWrite(rightblue,HIGH);digitalWrite(leftred,HIGH);digitalWrite(rightred,HIGH);digitalWrite(leftgreen,LOW);digitalWrite(rightgreen,LOW);
   // END CHANGE EYES GREEN
   
   rightshoulder.write(160);delay(1000);rightelbow.write(140);Serial.println("Right button"); leftshoulder.write(90);leftshoulder.write(0);delay(1000);leftelbow.write(20);delay(1000);servocenter();
 delay(500);rightshoulder.write(60);delay(1000);rightelbow.write(80);rightshoulder.write(160);delay(1000);
 
 rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
  rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
  rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
  rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
  
  servocenter();
     // CHANGE BLUE
     digitalWrite(leftblue,LOW);digitalWrite(rightblue,LOW);digitalWrite(leftred,HIGH);digitalWrite(rightred,HIGH);digitalWrite(leftgreen,HIGH);digitalWrite(rightgreen,HIGH);
// END CHANGE EYES BLUE
 }// end serial command K ARM TALKING

  //right arm abn elbow down Down Button Big remote
//if(results.value==412973352){rightshoulder.write(60);delay(1000);rightelbow.write(80);Serial.println("Left button");}
  
  // ARM TALKING2
   if(Calserial=='L'){
     //CHANGE EYES GREEN
   digitalWrite(leftblue,HIGH);digitalWrite(rightblue,HIGH);digitalWrite(leftred,HIGH);digitalWrite(rightred,HIGH);digitalWrite(leftgreen,LOW);digitalWrite(rightgreen,LOW);
   // END CHANGE EYES GREEN
   
   leftshoulder.write(50); rightshoulder.write(100);
   rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
 leftelbow.write(20);delay(250);leftelbow.write(90);delay(250);leftelbow.write(20);
 rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
 leftelbow.write(20);delay(250);leftelbow.write(90);delay(250);leftelbow.write(20);
  rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
 leftelbow.write(20);delay(250);leftelbow.write(90);delay(250);leftelbow.write(20);
  rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
 leftelbow.write(20);delay(250);leftelbow.write(90);delay(250);leftelbow.write(20);
  rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
 leftelbow.write(20);delay(250);leftelbow.write(90);delay(250);leftelbow.write(20);
  rightelbow.write(130);delay(250);rightelbow.write(80);delay(250);rightelbow.write(130);
 leftelbow.write(20);delay(250);leftelbow.write(90);delay(250);leftelbow.write(20);
 
 // CHANGE BLUE
     digitalWrite(leftblue,LOW);digitalWrite(rightblue,LOW);digitalWrite(leftred,HIGH);digitalWrite(rightred,HIGH);digitalWrite(leftgreen,HIGH);digitalWrite(rightgreen,HIGH);
// END CHANGE EYES BLUE
  servocenter();}// END ARM TALKING2


  }// end serial read
}// end of void loop


// Center all servos function..
void servocenter(){leftshoulder.write(130);leftelbow.write(90);leftleg.write(130);leftknee.write(90);rightshoulder.write(60);
rightelbow.write(80);rightleg.write(60);rightknee.write(90); //digitalWrite(leftblue,LOW);digitalWrite(rightblue,LOW);
}


